// -*- coding:euc-jp -*-
/*
  wimeΤlinux¦Ȥ̿
  soǥ쥯ȥˤä32ӥåȤǥѥ뤹ɬפ뤿Ω
  wime.dllȣУбΤǡdllǥ쥯ȥ˰ư⤷ʤ
*/

#include <sys/select.h>
#include <stdio.h>
#include <sys/types.h>
#include <sys/socket.h>
#include <sys/un.h>
#include <sys/stat.h>
#include <netdb.h>
#include <errno.h>
#include <string.h>
#include <stdlib.h>
#include <unistd.h>
#include <regex.h>
#include <X11/Xlib.h>
#include <libgen.h>
#include <fcntl.h>
#include <arpa/inet.h>
#include <netinet/in.h>
#include "lib/array.h"
#include "wimeio.h"
#include "exe/canna.h"
#include "lib/ut.h"
#include "lib/wimeconn.h"
#include "so/wimeapi.h"

Array CannaFds;
int ActiveFd;
int ListenNum; //³륽åȤο̾tcpȤȤ2

#define PERROR(s) fprintf(stderr,"%s:%d:%s\n",s,__LINE__,strerror(errno))

//char* SocketPath; //wimeconnΤΤȤ

/*
#ifndef SUN_LEN
#define SUN_LEN(n) (sizeof(n)-sizeof((n)->sun_path)+strlen((n)->sun_path))
#endif
*/

//ʸ̥ʸĤʤ
int get_line(FILE* stream,Array* ws)
{
    int c;
    while(c=fgetc(stream),c!=EOF && c!='\n'){
	ArAdd1(ws,&c);
    }
    return c!=EOF;
}

HinshiCor* read_hinshi_def(char* fn)
{
    FILE* fp;
    Array ht,lb;
    char* tok;
    HinshiCor hc,*tab;

    ArNew(&ht,sizeof(HinshiCor),NULL);
    ArNew(&lb,1,NULL);
    if((fp = fopen(fn,"r")) == NULL){
	tab = NULL;
    }else{
	int linenum=0;
	while(get_line(fp,&lb)){
	    ArAddChar(&lb,0);
	    ++linenum;
	    if(lb.use==1 || *(char*)lb.adr=='#')
		continue; //Ԥȹ
	    hc.Wcode = strtoul(lb.adr,&tok,0);
	    if(lb.adr == tok){
		//ͰʳΤΤ񤫤Ƥ
		printf("%s:%d:hinshi file format error\n",fn,linenum);
		continue;
	    }
	    char delim[]=" \t";
	    strtok(tok,delim); //ʻ̵̾
	    while((tok=strtok(NULL,delim)) != NULL){
		//ɽΥå
		regex_t reg;
		if(regcomp(&reg,tok,REG_EXTENDED) == 0){
		    hc.Ccode = strdup(tok);
		    ArAdd1(&ht,&hc);
		    regfree(&reg);
		}else{
		    printf("%s:%d:regex error\n",fn,linenum);
		}
	    }
	    ArClear(&lb);
	}
	fclose(fp);

	//λޡ
	hc.Ccode = NULL;
	ArAdd1(&ht,&hc);

	int bytesize = ht.use * ht.blocksize;
	tab = memcpy(malloc(bytesize),ht.adr,bytesize);
    }

    ArDelete(&ht);
    ArDelete(&lb);
    return tab;
}

#define SYSTEMWIDECONFDIR PREFIX "/share/wime"
#define HINSHIPATH "/hinshi"
#define maxint(a,b) ({int _a = (a), _b = (b); _a > _b ? _a : _b; })

/* եɤ߹
   ͡0= 1= 2=ƥ
*/
int ImReadSetting(void* _gd)
{
    int st=1;
    struct GlobalData_t* gd = (struct GlobalData_t*)_gd;
    char* home = getenv("HOME");
    char hinshifile[maxint(strlen(home)+1+sizeof(CONFDIR),sizeof(SYSTEMWIDECONFDIR))+sizeof(HINSHIPATH)+1];
    sprintf(hinshifile,"%s/%s",home,CONFDIR HINSHIPATH);
    free(gd->HinshiTab);
    if((gd->HinshiTab = read_hinshi_def(hinshifile)) == NULL){
	strcpy(hinshifile,SYSTEMWIDECONFDIR HINSHIPATH);
	gd->HinshiTab = read_hinshi_def(hinshifile);
	st = 2;
    }
    if(gd->HinshiTab == NULL)
	st = 0;
    return st;
}

static bool make_socket(int domain,int type,int proto,struct sockaddr* addr,size_t addrlen)
{
    int skt;

    if((skt = socket(domain,type,proto)) == -1)
	return false;
    if(bind(skt,addr,addrlen)!=0 || listen(skt,SOMAXCONN)!=0){
	close(skt);
	return false;
    }
    ArAdd1(&CannaFds,&skt);
    ++ListenNum;
    return true;
}

#define SERVER_ADDR "localhost"
#define SERVICE_NAME "canna"

/*
  bool֤
  socket_num pץο͡
  use_top 0=tcpϻȤʤ-1=ǥեȥӥ̾Ȥ >0=ݡֹȤ
*/
int ImInit(int socket_num,int use_tcp)
{
    errno = 0;
    ArNew(&CannaFds,sizeof(int),NULL);

    if((SocketPath = MakeSocketPath(socket_num)) == NULL)
	return 0;
    char* sock_path_cp = strdup(SocketPath);
    MkDir(dirname(sock_path_cp));
    free(sock_path_cp);
    chmod(SocketPath,0777);

    struct sockaddr_un sock_name;
    sock_name.sun_family = AF_UNIX;
    strcpy(sock_name.sun_path,SocketPath);
    if(!make_socket(AF_UNIX,SOCK_STREAM,0,(struct sockaddr*)&sock_name,SUN_LEN(&sock_name))){
	PERROR(__func__);
	return 0;
    }

    if(use_tcp){
	struct addrinfo *ai,*rp,hint={0};
	int st;
	char port[8];
	
	if(use_tcp > 0){
	    sprintf(port,"%d",use_tcp&0xffff);
	    hint.ai_family = AF_INET;
	    hint.ai_socktype = SOCK_STREAM;
	    rp = &hint;
	}else{
	    //ݡȻʤλϤǤƥǤ
	    strcpy(port,SERVICE_NAME);
	    rp = NULL;
	}
	if((st = getaddrinfo(SERVER_ADDR,port,rp,&ai)) != 0){
	    printf("%s:%s\n",__func__,gai_strerror(st));
	    if(st == EAI_SYSTEM)
		PERROR(__func__);
	    return 0;
	}

	((struct sockaddr_in*)(ai->ai_addr))->sin_port += htonl(socket_num);
	for(rp=ai; rp!=NULL; rp=rp->ai_next)
	    if(make_socket(rp->ai_family,rp->ai_socktype,rp->ai_protocol,rp->ai_addr,rp->ai_addrlen))
		break;
	if(rp == NULL){
	    PERROR(__func__);
	    return 0;
	}
	freeaddrinfo(ai);
    }
    return 1;
}

//äեǥץ֤
int ImSelect(void)
{
    int n,fd;
    fd_set rs;

    if(ArUsing(&CannaFds) == 0) //ʤ齪λ
	return 0;

    while(1){
	FD_ZERO(&rs);
	int maxfd = 0;

	for(n=0; n<ArUsing(&CannaFds); ++n){
	    fd = *(int*)ArElem(&CannaFds,n);
	    FD_SET(fd,&rs);
	    if(fd > maxfd)
		maxfd = fd;
	}

	if(select(maxfd+1,&rs,NULL,NULL,NULL) <= 0){
	    //PERROR(__func__);
	    if(errno==EINTR)
		continue;
	    return 0;
	}

	for(n=0; n<ArUsing(&CannaFds); ++n){
	    fd = *(int*)ArElem(&CannaFds,n);
	    if(FD_ISSET(fd,&rs))
		break;
	}

	if(n >= ListenNum)
	    break; //饤ȤȤ̿ä

	//fdˤlistenƤ륽åȤäƤ
	if((fd = accept(fd,NULL,NULL)) < 0){
	    PERROR(__func__);
	    continue;
	}
	ArAdd1(&CannaFds,&fd);
    }

    return ActiveFd = fd;
}

int ImRead(void* buf,int len)
{
    return (int)read(ActiveFd,buf,len);
}

//len񤭹ޤ줿1֤
bool ImWrite(const void* buf,int len)
{
    return write(ActiveFd,buf,len)==(ssize_t)len;
}

int ImDisconnect(void)
{
    close(ActiveFd);
    ArRemove(&CannaFds,ArFind(&CannaFds,0,&ActiveFd),1);
    return ActiveFd;
}

int ImCloseAll(void)
{
    for(int n=0; n<ArUsing(&CannaFds); ++n){
	shutdown(*(int*)ArElem(&CannaFds,n),SHUT_RD);
    }
    ArDelete(&CannaFds);
    unlink(SocketPath);
    return 1;
}

//Ϥ򼨤ɤxw롣äɥGetResultStrʸ롣
static Display* Disp;
void ImAuxInput(unsigned xw)
{
    XKeyPressedEvent ev;

    if(Disp == NULL){
	Disp = XOpenDisplay(NULL);
    }

    ev.type = KeyPress;
    ev.display = Disp;
    ev.root = XDefaultRootWindow(Disp);
    ev.window = xw;
    ev.subwindow = None;
    ev.time = CurrentTime;
    //ev.x = ev.y = 1; //ev.x_root = ev.y_root = 1;
    ev.same_screen = true;
    ev.state = AUX_INPUT_MOD;
    ev.keycode = 8;
    XSetInputFocus(Disp,xw,RevertToNone,CurrentTime); //ximǤɬ
    XSendEvent(Disp,xw,true,KeyPressMask,(XEvent*)&ev);
    XFlush(Disp);
}

__attribute__((destructor))
void close_disp()
{
    if(Disp != NULL)
	XCloseDisplay(Disp);

    //SemUnlink(); //!!!Ū˸ƤӽФ٤
}

//åֹ椬ɬפˤʤäΤǡŪ˸ƤӽФȤˤ롣
void ImSemUnlink(int socket_num)
{
    SemUnlink(socket_num);
}

/*󥹥ȥ饯ˤselectԤˤʤ˥åƤޤΤ
  Ū˸ƤӽФȤˤ롣*/
//__attribute__((constructor))
void ImSemStart(int socket_num)
{
    SemPost(socket_num);
}

//(C) 2009 thomas
